org.apache.poi.xslf.usermodel

## Class XSLFObjectShape

- java.lang.Object
- - org.apache.poi.xslf.usermodel.XSLFShape
  - - org.apache.poi.xslf.usermodel.XSLFGraphicFrame
    - - org.apache.poi.xslf.usermodel.XSLFObjectShape

- All Implemented Interfaces:
    GraphicalFrame<XSLFShape,XSLFTextParagraph>, ObjectShape<XSLFShape,XSLFTextParagraph>, PlaceableShape<XSLFShape,XSLFTextParagraph>, Shape<XSLFShape,XSLFTextParagraph>

      public class XSLFObjectShape
      extends XSLFGraphicFrame
      implements ObjectShape<XSLFShape,XSLFTextParagraph>

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.poi.xslf.usermodel.XSLFShape

      `XSLFShape.ReparseFactory<T extends org.apache.xmlbeans.XmlObject>`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected org.openxmlformats.schemas.drawingml.x2006.main.CTBlip` | `getBlip()`
    `protected org.openxmlformats.schemas.drawingml.x2006.main.CTBlipFillProperties` | `getBlipFill()`
    `protected java.lang.String` | `getBlipId()`
    `org.openxmlformats.schemas.presentationml.x2006.main.CTOleObject` | `getCTOleObject()`
    `java.lang.String` | `getFullName()` Returns the full name of the embedded object, e.g.
    `XSLFObjectData` | `getObjectData()`
    `XSLFPictureData` | `getPictureData()` Return the data on the (internal) picture.
    `java.lang.String` | `getProgId()` Returns the ProgID that stores the OLE Programmatic Identifier.
    `java.io.OutputStream` | `updateObjectData(ObjectMetaData.Application application, ObjectMetaData metaData)` Updates the ole data.

    - ### Methods inherited from class org.apache.poi.xslf.usermodel.XSLFGraphicFrame

      `getAnchor, getChart, getFallbackPicture, getFlipHorizontal, getFlipVertical, getRotation, getShapeType, hasChart, setAnchor, setFlipHorizontal, setFlipVertical, setRotation`

    - ### Methods inherited from class org.apache.poi.xslf.usermodel.XSLFShape

      `draw, fetchShapeProperty, getBgPr, getBgRef, getChild, getCNvPr, getFillPaint, getGrpSpPr, getParent, getPlaceholder, getPlaceholderDetails, getShapeId, getShapeName, getShapeProperties, getSheet, getSpStyle, getXmlObject, isPlaceholder, selectPaint, selectPaint, selectPaint, selectPaint, selectPaint, selectProperty, selectProperty, setParent, setPlaceholder`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.poi.sl.usermodel.ObjectShape

      `readObjectData, readObjectDataRaw`

    - ### Methods inherited from interface org.apache.poi.sl.usermodel.Shape

      `draw, getAnchor, getParent, getShapeId, getShapeName, getSheet`

    - ### Methods inherited from interface org.apache.poi.sl.usermodel.PlaceableShape

      `getAnchor, getFlipHorizontal, getFlipVertical, getParent, getRotation, getSheet, setAnchor, setFlipHorizontal, setFlipVertical, setRotation`

- - ### Method Detail

    - #### getCTOleObject

          @Internal
          public org.openxmlformats.schemas.presentationml.x2006.main.CTOleObject getCTOleObject()

    - #### getObjectData

          public XSLFObjectData getObjectData()

      Specified by:
        `getObjectData` in interface `ObjectShape<XSLFShape,XSLFTextParagraph>`
      Returns:
        the data object

    - #### getProgId

          public java.lang.String getProgId()

      Description copied from interface: `ObjectShape`
      Returns the ProgID that stores the OLE Programmatic Identifier. A ProgID is a string that uniquely identifies a given object, for example, "Word.Document.8" or "Excel.Sheet.8".
      Specified by:
        `getProgId` in interface `ObjectShape<XSLFShape,XSLFTextParagraph>`
      Returns:
        the ProgID

    - #### getFullName

          public java.lang.String getFullName()

      Description copied from interface: `ObjectShape`
      Returns the full name of the embedded object, e.g. "Microsoft Word Document" or "Microsoft Office Excel Worksheet".
      Specified by:
        `getFullName` in interface `ObjectShape<XSLFShape,XSLFTextParagraph>`
      Returns:
        the full name of the embedded object

    - #### getPictureData

          public XSLFPictureData getPictureData()

      Return the data on the (internal) picture. For an external linked picture, will return null
      Specified by:
        `getPictureData` in interface `ObjectShape<XSLFShape,XSLFTextParagraph>`
      Returns:
        the picture data for this picture.

    - #### getBlip

          protected org.openxmlformats.schemas.drawingml.x2006.main.CTBlip getBlip()

    - #### getBlipId

          protected java.lang.String getBlipId()

    - #### getBlipFill

          protected org.openxmlformats.schemas.drawingml.x2006.main.CTBlipFillProperties getBlipFill()

    - #### updateObjectData

          public java.io.OutputStream updateObjectData(ObjectMetaData.Application application,
                                                       ObjectMetaData metaData)
                                                throws java.io.IOException

      Description copied from interface: `ObjectShape`
      Updates the ole data. If there wasn't an object registered before, a new ole embedding is registered in the parent slideshow.

      For HSLF this needs to be a `POIFSFileSystem` stream.

      Specified by:
        `updateObjectData` in interface `ObjectShape<XSLFShape,XSLFTextParagraph>`
      Parameters:
        `application` - a preset application enum
        `metaData` - or a custom metaData object, can be `null` if the application has been set
      Returns:
        an `OutputStream` which receives the new data, the data will be persisted on `close()`
      Throws:
        `java.io.IOException` - if the linked object data couldn't be found or a new object data couldn't be initialized

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.